/*****************************************************************************
 * extstdlib.h - Header file for extended standard library (C/C++)           *
 *               Version 0.4                                                 *
 * ------------------------------------------------------------------------- *
 * Copyright 2002 by Rosario Piro (mailto: devfaust@users.sourceforge.net)   *
 *                                                                           *
 *   This program is free software; you can redistribute it and/or modify    *
 *   it under the terms of the GNU General Public License as published by    *
 *   the Free Software Foundation; either version 2 of the License, or       *
 *   (at your option) any later version.                                     *
 *                                                                           *
 *   This program is distributed in the hope that it will be useful,         *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *   GNU General Public License for more details.                            *
 *                                                                           *
 *   You should have received a copy of the GNU General Public License       *
 *   along with this program; if not, write to the Free Software             *
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA *
 *   or see http://www.gnu.org/copyleft/gpl.html                             *
 * ------------------------------------------------------------------------- */

#ifndef _EXTSTDLIB_H_
#define _EXTSTDLIB_H_

/*********************/
/*** include files ***/
/*********************/
#ifdef __cplusplus
# include <cstdlib>
#else /* Standard-C */
# include <stdlib.h>
# include <stdbool.h>
#endif

/***************************/
/*** preprocessor macros ***/
/***************************/
#define SHORTSTRLEN 64
#define LONGSTRLEN 256
#define MAXSTRLEN 2048

#define FALSE false
#define TRUE true

#define EPSILON 1.0E-10
#define EPSILONF 1.0E-6

#define EXITGOOD 0
#define EXITBAD  1

/************************/
/*** type definitions ***/
/************************/


/************************/
/*** global variables ***/
/************************/
extern bool isInteractive;
extern bool isVerbose;

#ifdef __cplusplus
 using namespace std;
#endif

/***************************/
/*** function prototypes ***/
/***************************/

#ifdef __cplusplus
extern "C" {
#endif
bool isZero(double value, double accuracy);
#ifdef __cplusplus
}
#endif

#define is0(a) isZero((a), EPSILON)

#ifdef __cplusplus
 // overload isZero(), has the same effect as is0() for C.
 inline bool isZero(double value) {
   return isZero(value, EPSILON);
 }
#endif


#endif /* #ifndef _EXTSTDLIB_H_ */
